
// change this to define if context ( November 1998 ) is to be used
#define USE_CONTEXT
// #undef USE_CONTEXT

// change this to define if new ( November 1998 ) rama map is to be used
#define USE_NEW_RAMA_MAP
// #undef USE_NEW_RAMA_MAP

// change 20-FEB-2003 Yu Shao:
// 	in struct model, add a char array to store the dssp secondary
// 	structure descriptors (HEGST_).

#define M 20
#ifdef USE_NEW_RAMA_MAP
#define MRAMA 11
#else
#define MRAMA 4
#endif
#define MDSSP 6
#define MCTXT 10
#define Tmax 5000
#define Np 1500  // No. of sequences in Pfam sample set ( total 10034 ) 

struct model{ 
  int   N ;                 // Number of nodes
  float bground[M] ;        // Background amino acid frequencies
  float rground[MRAMA] ;    // Background rama-type frequencies
  float dground[MDSSP] ;    // Background DSSP labelfrequencies
  float *prior ;            // Prior probabilities
  float **dih ;             // Dihedral angles of nodes 
  char  *ss ;               // HSSP structure label of nodes 
  float **a ;               // Transition matrix 
  float **b ;               // Emission probabilities for amino acids
  float **r ;               // Emission probabilities for Ramachandran regions
  float **d ;               // Emission probabilities for DSSP assignments
#ifdef USE_CONTEXT
  float cground[MCTXT] ;    // Background context frequencies
  float **c ;               // Emission probabilities for context assignments
#endif
  float **logb ;            // space for pre-computed log term

  // Yu Shao (23-FEB-2003)
  char ss_map[6];           // store the 6 ss characters
} ;

struct parent { 
  char  code[4] ;           // PDB code
  char  chainID ;           // chain ID
  short int T ;            // Length of parent
  char  *O_ptr ;            // Pointer to residue sequence of parent
  char  *O_ss;              // Pointer to HSSP structure label
  char  *O_rama;            // Pointer to HSSP structure label
  float *O_phi; 
  float *O_psi; 
  float *O_omg;            // Pointers to observed dihedral angles 
  float **O_profile;
  float *O_gap;
  float *O_ins;
  char  domainID;
  char  *O_context;
  float *weight;
  short int *resSeq ;            // residue number in PDB
  float **ca ;            // space for C-alpha coordinates (xyzca)
}; 

struct seq_struct {
  char  code[4] ;           // PDB code
  char  chainID ;           // Chain ID
  char  domainID;           // Domain ID 
  int T ;                   // Length of sequence
  int *O ;                  // Amino acid sequence, integer representation
  int *O_ss ;               // DSSP sequence, integer representation
  int *O_rama ;             // Ramachandran region sequence, int. repr.
  int *O_context ;          // Context sequence, int. repr. 
  float *weight;            // Weights
};

struct dbaserec { 
  short int seq_list;     // 
  short int resSeq ;      // PDB file residue number
  char code[4];           // PDB code
  char chainID;           // Chain letter
  char seq_resid;         // Residue
  char ss;                // DSSP assignment: H,G,E,S,T, or _
  char rotamer; 
  float xyzca[3];         // C-alpha coordinates
  float dih[3];           // Diheral angles 
  float csum; 
  float profile[20];      // Profile
  float gap_freq;         // Gap frequency
  float ins_freq;         // Insertion frequency
  char  domainID;         // Domain ID 
  char  context;          // Context
  short int generic[3];   // Blank
} ; 

struct dbaserec_ascii { 
  float profile[21] ;   /* profile[0]: gap, profile[1-20]: amino acids */
  char ss ;             /* DSSP assignment */
  int seq_down ;        /* Total no. residues - seq_list */ 
  int seq_list ;               
  int resSeq ;          /* PDB file residue number */
  float xyzca[3] ;      /* C-alpha coordinates */
  float dih[3] ;        /* Dihedral angles phi, psi, and omega */
  float chi  ;          /* Chi */
  char code[4] ;        /* PDB code */
  char chainID ;        /* Chain letter */
  char seq_resid ;      /* Residue */
  int nalign ;          /* Number of sequences in multiple seq. aligment */
} ; 


struct ssa {
  char scop_code[6] ;         
  int query_length ;
  char *query ;             // query sequence 
  float family_weight;      // Weight relative to other families
  int n_seqs ;              // No. of sequences in alignment
  int *seq_length ;         // Gapless lengths of individual sequences
  int align_length;         // Length of alignment 
  char *query_aligned;      // Residue or . for query in msa 
  char *O_ss;               // DSSP symbols for position in alignment
  char *O_context;          // Context for position in alignment
  char *O_rama;             // Ramachandran region for position in alignment
  char **msa;               // Multiple sequence alignment 
  short int **weight;       // Position dependent weights
} ;

// #ifdef USE_NEW_RAMA_MAP
//   extern float ramacen[][];
// #endif















