// Changes in modelf() to add mod->logb allocation  18-MAR-99
// 
// hmm_model_tools.C -- Routines included in this file :
//    void modelf ( char file[], struct model *modl )
//    void write_model (  struct model mod,
//    void intrans_get ( int ***intrans, struct model md )
//    void outtrans_get ( int ***outtrans, struct model md )
//    void snode_get ( int ***snode, struct model md )
//    void dnode_get ( int ***dnode, struct model md )
//    float rel_entropy ( float* a, float *b )
//    float Olambda( char *O_ptr, short int TT, struct model modll )
//    double bprof  ( int m,
//    double bprof_bg  ( int m,
//    double bprof_fast  ( int m,
//    double brdrat ( int m,
//    double flagrat ( int iflag ,
//    double flagrat_brdc ( int iflag ,
//    double flagrat_brdc ( int iflag ,
//    double flagrat_prof ( int iflag ,
//    double flagrat_prod ( int iflag ,
//    double flagrat_brdc_prod ( int iflag ,
//    double flagrat_brdc_fast ( int iflag ,
//
//    january 22, 1999
//*=========================================================================
//** Copyright 2003 Chris Bystroff
//**
//** Permission is hereby granted to use, execute, copy, distribute, modify,
//** and distribute in modified form this software for non-profit purposes,
//** provided this notice is retained in any and all copies.
//**
//** For for-profit usage, please contact bystrc@rpi.edu
//*=========================================================================
//----------------------------------------------------------------
// Set USE_ITHREE if hmm_model_tools is being compiled with one
// of the eval_mod series that uses 'voting' to predict Q3.
// change this to undef if ithree is not used in main.
//#undef USE_ITHREE
#define USE_ITHREE

// change this to def if new ( November 1998 ) rama map is to be used
#define USE_NEW_RAMA_MAP
//#undef USE_NEW_RAMA_MAP

// change this to def if context ( November 1998 ) is to be used
#define USE_CONTEXT
//#undef USE_CONTEXT

//#define READ_OLD_RAMA
#undef READ_OLD_RAMA
//#define WRITE_NEW_CONTEXT
#undef WRITE_NEW_CONTEXT


#include <stdio.h> 
#include <iostream.h> 
#include <fstream.h>
#include <string.h>
#include <stdlib.h>
#include <iostream.h>
#include <iomanip.h> 
#include <math.h>

//#include "hmm.h"
//#include "conversion.h"
//#include "hmm_model_tools.h"
//#include "ss_maps.h"
//#include "math.h"


/***************************************************************************

  rel_entropy.c - relative entropy between two aa distributions, log base 2

****************************************************************************/

//  float rel_entropy ( float* a, float *b ){
//  
//    int i;
//    float sum=0.;
//    float log2=log(2.);
//  
//    /*** Assumes that b[i] != 0 ( e.g. our background frequency ) ***/
//    for ( i=0 ; i<M ; i++ ){
//      if ( a[i] != 0 ){
//        sum += a[i] * log ( a[i]/b[i] );
//      }
//    }
//    sum /= log2;
//  
//    return sum;
//  
//  }

/******************************************************************/

double bprof  ( int m, 
	        int t, 
	        struct parent pa, 
	        struct model mod  ){

  int a ;
  // double prod=1. ; 
  double logsum=0.;

  /*
  // Amino acid emission
  double prod=1. ; 
  for ( a=0 ; a<M ; a++ ) {
    if ( pa.O_profile[t][a] != 0 ) { 
      prod *= pow ( mod.b[m][a]/mod.bground[a]+(double)EPS, 
                    pa.O_profile[t][a]*NCOUNT ) ; 
    }
  }
  return prod ; 
  */

  for ( a=0 ; a<M ; a++ ) {
    if ( pa.O_profile[t][a] != 0 ) { 
      //      if ( mod.b[m][a] == 0 ) return 0 ; 
      logsum += pa.O_profile[t][a] * NCOUNT * 
                log ( (double)(mod.b[m][a]+EPS /mod.bground[a]) );
    }
  }
  
  return exp(logsum) ; 

}

/******************************************************************/
// bprof_bg()  uses dot-product  CB 30-SEP-98

double bprof_bg  ( int m, 
	        int t, 
	        struct parent pa, 
	        struct model mod  ){

  int a; 
  //  double prod=0. ; 
  // double num=0., den=0.;
  double logsum=0.;

  // Amino acid emission

  /*
  // for ( a=0 ; a<M ; a++ ) {
  //   if ( pa.O_profile[t][a] != 0 ) { 
  //     prod += (mod.b[m][a]/mod.bground[a]) * pa.O_profile[t][a] ; 
  //   }
  // }
  */
  // below may be more appropriate, though den is calculated repeatedly 
  /*
  // for ( a=0 ; a<M ; a++ ){
  //   if ( pa.O_profile[t][a] != 0 ) { 
  //     num += mod.b[m][a] *  pa.O_profile[t][a] ; 
  //     den += mod.bground[a] * pa.O_profile[t][a] ;
  //   }
  // }
  // return num/den ; 

  //  return prod ; 
  */
  //  now uses pseudocounts based on bground  6-OCT-98
  for ( a=0 ; a<M ; a++ ) {
    if ( pa.O_profile[t][a] != 0 ) { 
      //        if ( mod.b[m][a] == 0 ) return 0 ; 
      logsum += pa.O_profile[t][a] * NCOUNT * 
                log ( (double)((mod.b[m][a]+(EPS*mod.bground[a])) 
                / ((1.+EPS)* mod.bground[a]) ) );
      //
      // This is the entropy score. SUM( profile * log-likelihood-ratio )
      //
    }
  }
  
  return exp(logsum) ; 
}

double bprof_fast  ( int m,
                int t,
                struct parent pa,
                struct model mod  ){

  int a;
  double logsum=0.;

  // Amino acid emission

  //  now uses pseudocounts based on bground  6-OCT-98
  for ( a=0 ; a<M ; a++ ) {
    if ( pa.O_profile[t][a] != 0 ) {
      logsum += pa.O_profile[t][a] * mod.logb[m][a] ;
      // logsum += pa.O_profile[t][a] * NCOUNT *
      //           log ( (double)((mod.b[m][a]+(EPS*mod.bground[a]))
      //           / ((1.+EPS)* mod.bground[a]) ) );
    }
  }

  return exp(logsum) ;
}

// 
//      scoring function for emmission probabilities

double brdrat ( int m, 
	        int t, 
	        int *O, 
	        struct parent pa, 
	        struct model mod  ){

  int k ; 
  double brat, rrat, drat ; 

  // Amino acid emission
  brat = mod.b[m][O[t]]/mod.bground[O[t]]; 

  // Ramachandran region
  k = irama( pa.O_rama[t] ) ;
  if ( k == -1 )
    rrat = 1 ;
  else 
    rrat = mod.r[m][k]/mod.rground[k] ;

  // Three state DSSP symbol 
  k = threestate( pa.O_ss[t] ) ;
  if ( k == -1 )
    drat = 1. ;
  else
    drat = mod.d[m][k]/mod.dground[k] ;
  
  return brat * rrat * drat ; 
  
}



double flagrat ( int iflag ,
                int m, 
	        int t, 
	        int *O, 
	        struct parent pa, 
	        struct model mod  ){

  int k, jflag ; 
  double brat, rrat, drat ; 
  brat = 1.; rrat = 1.; drat = 1.;
  
  // Three state DSSP symbol 
  jflag = iflag / 4 ; 
  if (jflag > 0) {
    k = threestate( pa.O_ss[t] ) ;
    if ( k > -1 ) drat = mod.d[m][k]/mod.dground[k] ;
  }

  // Ramachandran region
  iflag = iflag % 4 ;
  jflag = iflag / 2 ; 
  if (jflag > 0) {
    k = irama( pa.O_rama[t] ) ;
    if ( k > -1 ) rrat = mod.r[m][k]/mod.rground[k] ;
  }
  
  // Amino acid emission
  jflag = iflag % 2 ;
  if (jflag > 0) {
    brat = mod.b[m][O[t]]/mod.bground[O[t]]; 
  }
  
  return brat * rrat * drat ; 
  
}

/*********************************************************************************/

#ifdef USE_CONTEXT
double flagrat_brdc ( int iflag ,
		      int m,   // node label 
		      int t,   // position 
		      struct seq_struct sqs, 
		      struct model mod  ){

  int k, jflag, i_res ; 
  double brat, rrat, drat, crat; 
  brat = 1.; rrat = 1.; drat = 1., crat=1.;

  // Context symbol

  jflag = iflag / 8 ;
  if ( jflag > 0 ){
    k = sqs.O_context[t] ;
    if ( k > -1 ) crat = mod.c[m][k]/mod.cground[k] ;
  }

  // Three state DSSP symbol 
  iflag = iflag % 8 ;
  jflag = iflag / 4 ; 
  if (jflag > 0) {
    k = sqs.O_ss[t] ;
    if ( k > -1 ) drat = mod.d[m][k]/mod.dground[k] ;
  }

  // Ramachandran region
  iflag = iflag % 4 ;
  jflag = iflag / 2 ; 
  if (jflag > 0) {
    k = sqs.O_rama[t] ;
    if ( k > -1 ) rrat = mod.r[m][k]/mod.rground[k] ;
  }
  
  // Amino acid emission
  jflag = iflag % 2 ;
  if (jflag > 0) {
    i_res = sqs.O[t];
    if ( i_res != 20 ){ 
      brat = mod.b[m][i_res]/mod.bground[i_res];
      // brat =  pow ( mod.b[m][i_res]/mod.bground[i_res], sqs.weight[t] ) ;
    }
  }
  
  return brat * rrat * drat * crat ; 
  
}
#endif 

/********************* Old version

#ifdef USE_CONTEXT
double flagrat_brdc ( int iflag ,
		      int m,   // node label 
		      int t,   // position 
		      struct parent pa, 
		      struct model mod  ){

  int k, jflag, i_res ; 
  double brat, rrat, drat, crat; 
  brat = 1.; rrat = 1.; drat = 1., crat=1.;

  // Context symbol

  jflag = iflag / 8 ;
  if ( jflag > 0 ){
    k = icontext ( pa.O_context[t] ) ;
    if ( k > -1 ) crat = mod.c[m][k]/mod.cground[k] ;
  }

  // Three state DSSP symbol 
  iflag = iflag % 8 ;
  jflag = iflag / 4 ; 
  if (jflag > 0) {
    k = threestate( pa.O_ss[t] ) ;
    if ( k > -1 ) drat = mod.d[m][k]/mod.dground[k] ;
  }

  // Ramachandran region
  iflag = iflag % 4 ;
  jflag = iflag / 2 ; 
  if (jflag > 0) {
    k = irama( pa.O_rama[t] ) ;
    if ( k > -1 ) rrat = mod.r[m][k]/mod.rground[k] ;
  }
  
  // Amino acid emission
  jflag = iflag % 2 ;
  if (jflag > 0) {
    i_res = oneamino(pa.O_ptr[t]);
    if ( i_res != 20 ){ 
      brat = mod.b[m][i_res]/mod.bground[i_res];
      // brat =  pow ( mod.b[m][i_res]/mod.bground[i_res], pa.weight[t] ) ;
    }
  }
  
  return brat * rrat * drat * crat ; 
  
}
#endif 
**********/

// version of flagrat to use bprof_bg  CB 26-SEP-98
double flagrat_prof ( int iflag ,
                int m, 
	        int t, 
	        int *O, 
	        struct parent pa, 
	        struct model mod  ){

  int k, jflag ; 
  double brat, rrat, drat ; 
  brat = 1.; rrat = 1.; drat = 1.;
  
  // Three state DSSP symbol 
  jflag = iflag / 4 ; 
  if (jflag > 0) {
    k = threestate( pa.O_ss[t] ) ;
    if ( k > -1 ) drat = mod.d[m][k]/mod.dground[k] ;
  }

  // Ramachandran region
  iflag = iflag % 4 ;
  jflag = iflag / 2 ; 
  if (jflag > 0) {
    k = irama( pa.O_rama[t] ) ;
    if ( k > -1 ) rrat = mod.r[m][k]/mod.rground[k] ;
  }
  
  // Amino acid emission
  jflag = iflag % 2 ;
  if (jflag > 0) {
    // brat = mod.b[m][O[t]]/mod.bground[O[t]]; 
    brat = bprof_bg(m,t,pa,mod) ;
  }
  
  return brat * rrat * drat ; 
  
}
// flagrat_prod    uses bprof, which calculates the multinomial score
// now uses bprof_bg with pseudocounts  6-OCT-98 
double flagrat_prod ( int iflag ,
                int m, 
	        int t, 
	        int *O, 
	        struct parent pa, 
	        struct model mod  ){

  int k, jflag ; 
  double brat, rrat, drat ; 
  brat = 1.; rrat = 1.; drat = 1.;
  
  // Three state DSSP symbol 
  jflag = iflag / 4 ; 
  if (jflag > 0) {
    k = threestate( pa.O_ss[t] ) ;
    if ( k > -1 ) drat = mod.d[m][k]/mod.dground[k] ;
  }

  // Ramachandran region
  iflag = iflag % 4 ;
  jflag = iflag / 2 ; 
  if (jflag > 0) {
    k = irama( pa.O_rama[t] ) ;
    if ( k > -1 ) rrat = mod.r[m][k]/mod.rground[k] ;
  }
  
  // Amino acid emission
  jflag = iflag % 2 ;
  if (jflag > 0) {
    // brat = mod.b[m][O[t]]/mod.bground[O[t]]; 
    brat = bprof_bg(m,t,pa,mod) ;
  }
  
  return brat * rrat * drat ; 
  
}
// flagrat_brdc_prod    uses bprof, which calculates the multinomial score
// now uses bprof_bg with pseudocounts  6-OCT-98 
#ifdef USE_CONTEXT
double flagrat_brdc_prod ( int iflag ,
                int m, 
	        int t, 
	        int *O, 
	        struct parent pa, 
	        struct model mod  ){

  // iflag = 1 if b + 2 if r + 4 if d + 8 if c
  // m = hmmstr state
  // t = sequence position
  // O (not zero) =  integer for amino acid (not used here)
  // pa = parent sequence profile(b), angles(r), dssp symbols(d) and contact symbols(c)
  // mod = hmmstr
  int k, jflag ; 
  double brat, rrat, drat, crat ; 
  brat = 1.; rrat = 1.; drat = 1.; crat=1.;

  // NOT-state 19-feb-99
  if (m == 0) return brat; // == 1
  
  // Context symbol
  jflag = iflag / 8 ;
  if ( jflag > 0 ){
    k = icontext ( pa.O_context[t] ) ;
    // if ( k > -1 ) crat = mod.c[m][k]/mod.cground[k] ;
    if ( k > -1 ) crat =  ( mod.c[m][k] + EPS * mod.cground[k] )
                         /((1+EPS)*mod.cground[k]) ;
  }

  // Three state DSSP symbol 
  iflag = iflag % 8 ;
  jflag = iflag / 4 ; 
  if (jflag > 0) {
    k = threestate( pa.O_ss[t] ) ;
    // if ( k > -1 ) drat = mod.d[m][k]/mod.dground[k] ;
    if ( k > -1 ) drat = (mod.d[m][k] + EPS * mod.dground[k] )
                        /((1+EPS)*mod.dground[k]) ;
  }

  // Ramachandran region
  iflag = iflag % 4 ;
  jflag = iflag / 2 ; 
  if (jflag > 0) {
    k = irama( pa.O_rama[t] ) ;
    // if ( k > -1 ) rrat = mod.r[m][k]/mod.rground[k] ;
    if ( k > -1 ) rrat = (mod.r[m][k] + EPS * mod.rground[k] )
                        /((1+EPS)*mod.rground[k]) ;
  }
  
  // Amino acid emission
  jflag = iflag % 2 ;
  if (jflag > 0) {
    // brat = mod.b[m][O[t]]/mod.bground[O[t]]; 
    brat = bprof_bg(m,t,pa,mod) ;
  }
  
  return brat * rrat * drat * crat; 
  
}

// new version 18-mar-99 uses bprof_fast

double flagrat_brdc_fast ( int iflag ,
                int m, 
	        int t, 
	        int *O, 
	        struct parent pa, 
	        struct model mod  ){

  int k, jflag ; 
  double brat, rrat, drat, crat ; 
  brat = 1.; rrat = 1.; drat = 1.; crat=1.;

  // NOT-state 19-feb-99
  if (m == 0) return brat; // == 1
  
  // Context symbol
  jflag = iflag / 8 ;
  if ( jflag > 0 ){
    k = icontext ( pa.O_context[t] ) ;
    // if ( k > -1 ) crat = mod.c[m][k]/mod.cground[k] ;
    if ( k > -1 ) crat =  ( mod.c[m][k] + EPS * mod.cground[k] )
                         /((1+EPS)*mod.cground[k]) ;
  }

  // Three state DSSP symbol 
  iflag = iflag % 8 ;
  jflag = iflag / 4 ; 
  if (jflag > 0) {
//  k = threestate( pa.O_ss[t] ) ;
    k = sixstate( pa.O_ss[t] ) ;
    // if ( k > -1 ) drat = mod.d[m][k]/mod.dground[k] ;
    if ( k > -1 ) drat = (mod.d[m][k] + EPS * mod.dground[k] )
                        /((1+EPS)*mod.dground[k]) ;
  }

  // Ramachandran region
  iflag = iflag % 4 ;
  jflag = iflag / 2 ; 
  if (jflag > 0) {
    k = irama( pa.O_rama[t] ) ;
    // if ( k > -1 ) rrat = mod.r[m][k]/mod.rground[k] ;
    if ( k > -1 ) rrat = (mod.r[m][k] + EPS * mod.rground[k] )
                        /((1+EPS)*mod.rground[k]) ;
  }
  
  // Amino acid emission
  jflag = iflag % 2 ;
  if (jflag > 0) {
    // brat = mod.b[m][O[t]]/mod.bground[O[t]]; 
    brat = bprof_fast(m,t,pa,mod) ;
  }
  
  return brat * rrat * drat * crat; 
  
}
#endif

//            
//				    November 9, 1998
//
//   modelf.C - read model from file written in Chris' format
//		
//              Input:   filename
//              Output:  Pointer to model structure containing
//                       N       - #nodes including unknown
//                       bground - background frequencies 
//                       prior   - priors for nodes
//                       a       - transition probabilities
//                       b       - emission probabilities
//
//
// keywords in hmm files
#define BGFREQS "default_bg_freqs"
#define NODE "node"
#define NODE_SS "node_ss"
#define NODE_RAMA "node_rama"
#define NODE_CONTEXT "node_context"
#define TRANSIT_FREQS "transit_freqs"
#define NUM_NODES "num_nodes"
#define UNK_NODE "unk_node"


void modelf ( char file[], struct model *modl ) 
{

  char word[200];
  int i, j, n, N, nnodes;  
  float sumd[MDSSP], sumr[MRAMA], sumc[MCTXT];
  float x;
#ifdef USE_ITHREE
  // extern int ithree[] ;
  // change by Yu Shao
  int ithree[MDSSP] ;
#endif

  ifstream in(file);
  if ( in.bad() ) {
    cerr << "Unable to open model file\n";
    exit (8);
  }


#ifdef USE_ITHREE
  // default DSSP vector order :  HEGST_    i.e. ss_map 6 HEGST_
  ithree[0] = threestate('H') ;
  ithree[1] = threestate('E') ;
  ithree[2] = threestate('G') ;
  ithree[3] = threestate('S') ;
  ithree[4] = threestate('T') ;
  ithree[5] = threestate('_') ;
#endif

  // Background frequencies
  cout << "Getting " << BGFREQS << endl << flush ;

  in >> word;
  while (!in.eof() && strcmp(word,BGFREQS)!=0) {
    in.ignore(100,'\n');
    in >> word ;  
#ifdef USE_ITHREE
    // DSSP vector order :  i.e: ss_map 6 HEGST_
    if (strcmp(word,"ss_map")==0) {
      in >> word ; sscanf(word,"%d",&j) ;
      in >> word ;
      cout << "Three-state assigments: " << j << "   " ;
      for (i=0; i<j ; i++) {
        ithree[i] = threestate(*(word+i)) ;
        cout << *(word+i) << "=" << ithree[i] << " " ;

	// Yu Shao 20-FEB-2003
	modl->ss_map[i] = word[i];
      }
      cout << endl << flush ;
      in.ignore(100,'\n');
      in >> word ;  
    }
#endif
  }

  for (i=0;i<MRAMA;i++) sumr[i]=0.;
  for (i=0;i<MDSSP;i++) sumd[i]=0.;
#ifdef USE_CONTEXT
  for (i=0;i<MCTXT;i++) sumc[i]=0.;
#endif 

  if (in.eof()) {
    in.seekg(0,ios::beg);
    cout << "KEYWORD default_bg_freqs NOT FOUND!" << endl << flush;
    cout << "using 0.05 for all backgroud freqs" << endl << flush;
    for ( i = 0 ; i < M ; i++ ) modl->bground[i] = 0.05 ;
  } else {
    for ( i = 0 ; i < M ; i++ ) in >> modl->bground[i] ;
  }
  cout << "Background AA freqs: " ;
  for (i = 0 ; i < M ; i++ ) cout << setw(8) << modl->bground[i] << " " ;
  cout << endl << flush ;

  // Number of nodes

  cout << "Getting " << NUM_NODES << endl << flush ;
  in >> word;
  while(!in.eof() && strcmp(word,NUM_NODES)!=0) {
    in.ignore(100,'\n');
    in >> word ;  
  }
  if (in.eof()) {
    in.seekg(0,ios::beg);
    cout << "KEYWORD num_nodes NOT FOUND!" << endl << flush;
    exit(8);
  }
  in >> nnodes ;
  modl->N = nnodes + 1 ;
  N  = modl->N ;  

  // Memory allocation 
  cout << "allocating " << N << " nodes." << endl << flush ;

  modl->prior = new float[N] ;
  modl->dih   = new float*[N] ; 
  for ( i = 0 ; i < N ; i++ ) modl->dih[i]   = new float[3] ; 
  modl->ss = new char[N] ;
  modl->a     = new float*[N] ; 
  for ( i = 0 ; i < N ; i++ ) modl->a[i]     = new float[N] ; 
  modl->b       = new float*[N] ;
  for ( i = 0 ; i < N ; i++ ) modl->b[i]     = new float[M] ; 
  modl->r       = new float*[N] ;
  for ( i = 0 ; i < N ; i++ ) modl->r[i]     = new float[MRAMA] ; 
  modl->d       = new float*[N] ;
  for ( i = 0 ; i < N ; i++ ) modl->d[i]     = new float[MDSSP] ; 
#ifdef USE_CONTEXT
  modl->c       = new float*[N] ;
  for ( i = 0 ; i < N ; i++ ) modl->c[i]     = new float[MCTXT] ; 
#endif
  modl->logb       = new float*[N] ;
  for ( i = 0 ; i < N ; i++ ) modl->logb[i]     = new float[M] ; 

  // Unknown node 

  cout << "Getting " << UNK_NODE << endl << flush ;
  while(!in.eof() && strcmp(word,UNK_NODE)!=0) {
    in.ignore(100,'\n');
    in >> word ;
  }
  if (in.eof()) {
    in.seekg(0,ios::beg);
    cout << "KEYWORD unk_node NOT FOUND!" << endl << flush;
    cout << "using 0.01 for prior of unk_node" << endl << flush;
    cout << "using 0.05 for freqs of unk_node" << endl << flush;
    modl->prior[0] = 0.01;
    for ( i = 0;  i < M ; i++ ) modl->b[0][i] = 0.05;    
  } else {
    in >> word ;
    in >> modl->prior[0];
    for ( i = 0;  i < M ; i++ ) in >> modl->b[0][i];    
  }
  modl->dih[0][0] = -75. ;
  modl->dih[0][1] = -15. ;
  modl->dih[0][2] = 180. ;
  modl->ss[0] = '_' ;

  // get DSSP distribution for unknown state
  while(!in.eof() && strcmp(word,"unk_node_ss")!=0) {
    if (strcmp(word,NODE)==0) break ;
    in.ignore(100,'\n');
    in >> word ;
  }
  if (strcmp(word,"unk_node_ss")==0) {
    cout << "Found unk_node_ss line." << endl << flush ;
    in >> modl->ss[0] ;
    for ( i = 0;  i < MDSSP ; i++ ) {
      in >> modl->d[0][i];    
      sumd[i] += modl->prior[0] * modl->d[0][i] ;
    }
  }

  // get RAMA distribution for unknown state
  while(!in.eof() && strcmp(word,"unk_node_rama")!=0) {
    if (strcmp(word,NODE)==0) break ;
    in.ignore(100,'\n');
    in >> word ;
  }
  if (strcmp(word,NODE)!=0) {
    cout << "Found unk_node_rama line." << endl << flush ;
    in >> word ;  // RAMA region letter
#ifdef READ_OLD_RAMA
      for ( i = 0;  i < MRAMA ; i++ ) {
        modl->r[0][i] = 0. ;    
      }
      modl->r[0][1] = 1. ;    
      sumr[1] += 1.;
#else
    for ( i = 0;  i < MRAMA ; i++ ) {
      in >> modl->r[0][i];    
      sumr[i] += modl->prior[0] * modl->r[0][i] ;
    }
#endif
  }
  if (in.eof()) {
    cout << "MISSING line(s) in model file before nodes!! " << endl ;
    exit(8);
  }

  // Known nodes 

  cout << "Getting " << NODE << " lines." << endl ;
  for ( n = 1;  n < N ; n++ ){

    while(!in.eof() && strcmp(word,NODE)!=0) {
      if (strcmp(word,TRANSIT_FREQS)==0) break ;
      in.ignore(100,'\n');
      in >> word ;
    }
    if (strcmp(word,TRANSIT_FREQS)==0) break ;
    if (in.eof()) {
      cout << "MISSING " << NODE << 
       " line(s) in model file!! " << n << endl ;
      exit(8);
    }
    if (strcmp(word,NODE)==0) {
      in >> word;   // node number
      in >> word ;  // node character
      in >> word ;  // motif number
      in >> modl->prior[n] ;
      in >> modl->dih[n][0] ;
      in >> modl->dih[n][1] ;    
      in >> modl->dih[n][2] ;
      in >> word ;  // component= field
      in >> word ;  // component number
      in >> word ;  // class= field
      in >> word ;  // ss= field
      modl->ss[n] = word[3];  // overwritten if node_ss lines are present.
      in.ignore(100,'\n');
      for ( i = 0;  i < M ; i++ ) in >> modl->b[n][i];   
    }

    // get DSSP distribution for node
    while(!in.eof() && strcmp(word,NODE_SS)!=0) {
      if (strcmp(word,NODE)==0) break ;
      if (strcmp(word,TRANSIT_FREQS)==0) break ;
      in.ignore(100,'\n');
      in >> word ;
    }
    if (in.eof()) {
      cout << "MISSING " << NODE_SS << 
      " line(s) in model file!! " << n << endl ;
      exit(8);
    }
    if (strcmp(word,NODE_SS)==0) {
      in >> word ;  // node number
      in >> word ;  // node letter
      in >> modl->ss[n] ;  // predimonant DSSP label 
      // double junk; 
      // junk = 0;
      for ( i = 0;  i < MDSSP ; i++ ) {
        in >> modl->d[n][i];   
        // junk += modl->d[n][i];	
        sumd[i] += modl->prior[n] * modl->d[n][i] ;
      }
      // cout << "Read HMM state " << n << " sum(P(ss|Qn)) = " << junk << endl;
    }

    // get RAMA , Ramachandran angle region emission vector
    while(!in.eof() && strcmp(word,NODE_RAMA)!=0) {
      if (strcmp(word,NODE)==0) break ;
      if (strcmp(word,TRANSIT_FREQS)==0) break ;
      in.ignore(100,'\n');
      in >> word ;
    }
    if (in.eof()) {
      cout << "MISSING " << NODE_RAMA << 
       " line(s) in model file!! " << n << endl ;
      exit(8);
    }
    if (strcmp(word,NODE_RAMA)==0) {
      in >> word ;  // node number
      in >> word ;  // node letter
      in >> word ;  // rama letter
#ifdef READ_OLD_RAMA
      for ( i = 0;  i < MRAMA ; i++ ) {
        modl->r[n][i] = 0. ;    
      }
      modl->r[n][1] = 1. ;    
      sumr[1] += 1.;
#else
      for ( i = 0;  i < MRAMA ; i++ ) {
        in >> modl->r[n][i];    
        sumr[i] += modl->prior[n] * modl->r[n][i] ;
      }
#endif
    }

#ifdef USE_CONTEXT
    // get CONTEXT, context emission vector
    while(!in.eof() && strcmp(word,NODE_CONTEXT)!=0) {
      if (strcmp(word,NODE)==0) break ;
      if (strcmp(word,TRANSIT_FREQS)==0) break ;
      in.ignore(100,'\n');
      in >> word ;
    }
    if (in.eof()) {
      cout << "MISSING " << NODE_RAMA << 
      " line(s) in model file!! " << n << endl ;
      exit(8);
    }
    if (strcmp(word,NODE_CONTEXT)==0) {
      in >> word ;  // node number
      in >> word ;  // node letter
      in >> word ;  // context letter
      for ( i = 0;  i < MCTXT ; i++ ) {
        in >> modl->c[n][i];    
        sumc[i] += modl->prior[n] * modl->c[n][i] ;
      }
    }
#endif

  }

  // save background frequencies for RAMA labels
  x = 0.; for (i=0;i<MRAMA;i++) x += sumr[i];
  if (x > 0.) {
    for ( i = 0;  i < MRAMA ; i++ ) modl->rground[i] = sumr[i]/x ;
  } else {  // this should never be used!
    for ( i = 0;  i < MRAMA ; i++ ) modl->rground[i] = 1./((float) MRAMA) ;
  }
  cout << "Background RAMA labels: "  << setiosflags(ios::fixed ) ;
  for ( i = 0;  i < MRAMA ; i++ ) {
    cout << setw(8) << setprecision(4) << modl->rground[i];
  }
  cout << endl << flush ;


  // save background frequencies for DSSP labels
  x = 0.; for (i=0;i<MDSSP;i++) x += sumd[i];
  if (x > 0.) {
    for ( i = 0;  i < MDSSP ; i++ ) modl->dground[i] = sumd[i]/x ;
  } else {  // this should never be used!
    for ( i = 0;  i < MDSSP ; i++ ) modl->dground[i] = 1./((float) MDSSP) ;
  }
  cout << "Background DSSP labels: " ;
  for ( i = 0;  i < MDSSP ; i++ ) {
    cout << setw(8) << setprecision(4) << modl->dground[i];
  }
  cout << endl << flush ;

#ifdef USE_CONTEXT
  // save background frequencies for CONTEXT labels
  x = 0.; for (i=0;i<MCTXT;i++) x += sumc[i];
  if (x > 0.) {
    for ( i = 0;  i < MCTXT ; i++ ) modl->cground[i] = sumc[i] ;
  } else {  // this should never be used!
    for ( i = 0;  i < MCTXT ; i++ ) modl->cground[i] = 1./((float) MCTXT) ;
  }
  cout << "Background CTXT labels: " ;
  for ( i = 0;  i < MCTXT ; i++ ) {
    cout << setw(8) << setprecision(4) << modl->cground[i];
  }
  cout << endl << flush ;
#endif 

  // Transition matrix 

  cout << "Getting " << TRANSIT_FREQS << endl << flush ;
  while(!in.eof() && strcmp(word,TRANSIT_FREQS)!=0 ) {
    in.ignore(100,'\n');
    in >> word ;
  }
  if (in.eof()) {
    cout << "MISSING transition freqs in model file!! " << endl << flush;
    exit(8);
  }

  // read transition frequencies
  if (strcmp(word,TRANSIT_FREQS)==0 ) {
    in.ignore(300,'\n');
    for ( i = 0; i < modl->N; i++ ){
      // double junk;
      // junk = 0;
      for ( j = 0; j < modl->N; j++ ) {
	      in >> modl->a[i][j] ;
	      // junk += modl->a[i][j];
      }
      // cout << "Read HMM transition matrix, line " << i + 1 << ": sum (P) = " << junk << endl;
    } 
  } 
  cout << "Done reading " << N*N << " transition freqs" << endl << flush ;

  in.close();

}


//
//                                             April 16, 1998
//
//     write_model.C - Write model to output file  
//
//            Input:  1. Model structure 
//                    2. Initial model-file name 
//                    3. Output model-file name 
//                    4. 0 if no new nodes
//                       -1 if L unit was added to model 
//                       # of original node if 
//                       new node was created by splitting
//                       ( structural information copied to final (new) node )
//                    5. Header string 
//

void write_model (  struct model mod, 
		    char infile[], 
		    char outfile[] ,  
		    int spnode, 
		    char header[] ) {
  
  int i, j, jj, N ; 
  char line[300] ;
  char aline[300] ;
  char *l_ptr ;
  char nodechar,ctxtchar ;
  char spline[300], spline_ss[300], spline_rama[300], spline_context[300]; 
#ifdef USE_NEW_RAMA_MAP
  char ramach[] = "HGBEdbeLlxc" ;
  extern float ramacen[MRAMA][2] ;
#else
  char ramach[]="HELX";
#endif
  char context_ch[] = "amnhdstul_";
  char dsspletter[]="HEGST_";
  float x;

  N = mod.N ;

  ifstream in ( infile ) ; 
  ofstream out( outfile ) ;

  out << header << endl ; 

  // Print number of nodes 

  // Get num_nodes line ***required***
  in.getline( line, sizeof(line) ) ; 
  while  ( strncmp(line,"num_nodes ",10)!=0 ) {
    out << line << endl ; 
    in.getline( line, sizeof(line) ) ; 
  }

  sprintf(line+10,"%3d",N-1);
  out << line << endl ; 
  in.getline( line, sizeof(line) ) ; 

  /*            
  out.seekp ( -96, ios::cur ) ; out << setw(3) << N-1 ; 
  out.seekp (  92, ios::cur ) ; out << endl ;      
  */

  // Print unk_node parameters 

  // Get unk_node line ***required***

  while  ( strncmp(line,"unk_node ",9)!=0 ) {
    out << line << endl ; 
    in.getline( line, sizeof(line) ) ; 
  }

  sprintf(line+11,"%9.5f",mod.prior[0]);
  out << line << endl ; 
  in.getline( line, sizeof(line) ) ; 

  // look for unk_node_ss line  ***optional***
  while  ( strncmp(line,"unk_node_ss ",12)!=0 ) {
    if ( strncmp(line,"node ",5)==0 ) break ;
    if ( strncmp(line,"unk_node_rama ",14)==0 ) break ;
    out << line << endl ; 
    in.getline( line, sizeof(line) ) ; 
  }
  // write out new unk_node_ss line
  if  ( strncmp(line,"unk_node_ss ",12)==0 ) {
    // modifications to unk_node_ss line 
    i = 0;  // unknown node
    l_ptr = line+15;
    x = 0.; jj=MDSSP-1 ;    // write out d-vector and get maximum
    for (j=0 ; j<MDSSP ; j++) {
      if (mod.d[i][j] > x) {x = mod.d[i][j]; jj = j ; }
    }
    for (j=0 ; j<MDSSP ; j++) {
      sprintf(l_ptr,"%8.3f",mod.d[i][j] ) ;  // NOTE: eol gets overwritten!
      l_ptr += 8;
    }
    line[12] = dsspletter[jj] ;
    out << line << endl ; 
    in.getline( line, sizeof(line) ) ; 
  }

  // look for unk_node_rama line
  while  ( strncmp(line,"unk_node_rama ",14)!=0 ) {
    if ( strncmp(line,"node ",5)==0 ) break ;
    out << line << endl ; 
    in.getline( line, sizeof(line) ) ; 
  }
  // write out new unk_node_rama line
  if  ( strncmp(line,"unk_node_rama ",14)==0 ) {
    // add modifications to unk_node_rama line here************
    i = 0;  // unknown node
    l_ptr = line+17;
    x = 0.; jj=MRAMA-1 ;    // write out r-vector and get maximum
    for (j=0 ; j<MRAMA ; j++) {
      if (mod.r[i][j] > x) {x = mod.r[i][j]; jj = j; }
      sprintf(l_ptr,"%8.3f",mod.r[i][j]) ;  // NOTE: eol gets overwritten!
      l_ptr += 8;
    }
    line[14] = ramach[jj] ;
    out << line << endl ; 
    in.getline( line, sizeof(line) ) ; 
  }

  // Print known node parameters 

  for ( i=1 ; i<N ; i++ ){

    // look for node line i
    while  ( strncmp(line,"node ",5)!=0 ) {
      if (strncmp(line,"transit_freqs ",14)==0) break ;
      out << line << endl ;  // output miscelaneous lines
      in.getline( line, sizeof(line) ) ; 
    }
    // write out new NODE line
    if ( strncmp(line,"node ",5)==0 ) {
       // write out new mod.prior, overwrite the \0 character
        nodechar = *(line+9) ;
        sprintf(line+15,"%7.5f",mod.prior[i]); *(line+22) = ' ' ;
#ifdef USE_NEW_RAMA_MAP
        x = 0.; jj=-1 ;
        for (j=0;j<MRAMA;j++) if (mod.r[i][j] > x) {x = mod.r[i][j]; jj=j; }
        if (jj >= 0) {
          sprintf(line+22,"%8.2f",ramacen[jj][0]);
          sprintf(line+30,"%8.2f",ramacen[jj][1]);
          sprintf(line+38,"%8.2f", jj==MRAMA-1 ? 0. : 180. );
          *(line+46) = ' ';
        }
#endif
        out << line << endl ; 
        if ( i==spnode ) strcpy ( spline, line ) ; 

       // write out new b[] vector
        in.getline( line, sizeof(line) )  ;   // 1st line of b[]
        for (j=0 ; j<10 ; j++) sprintf(line+(j*8),"%8.5f",mod.b[i][j]) ;
        out << line << endl ; 
        in.getline( line, sizeof(line) )  ;   // 2nd line of b[]
        for (j=10 ; j<20 ; j++) sprintf(line+((j-10)*8),"%8.5f",mod.b[i][j]) ;
        out << line << endl << flush ; 
        in.getline( line, sizeof(line) )  ;   // whatever follows it
    }

    // look for NODE_SS line
    while  ( strncmp(line,"node_ss ",8)!=0 ) {
      if  ( strncmp(line,"node ",5)==0 ) break;
      if  ( strncmp(line,"transit_freqs ",14)==0 ) break;
      out << line << endl ; 
      in.getline( line, sizeof(line) ) ; 
    }
    if  ( strncmp(line,"node ",5)==0 ) continue ;
    if  ( strncmp(line,"transit_freqs ",14)==0 ) break;

    // output new NODE_SS line
    if ( strncmp(line,"node_ss ",8)==0 ) {
      l_ptr = line+18;
      x = 0.; jj=MDSSP-1 ;    // write out d-vector and get maximum
      for (j=0 ; j<MDSSP ; j++) {
        if (mod.d[i][j] > x) {x = mod.d[i][j]; jj = j ; }
      }
      for (j=0 ; j<MDSSP ; j++) {
        sprintf(l_ptr,"%8.3f",mod.d[i][j]) ;  // NOTE: eol gets overwritten!
        l_ptr += 8;
      }
      line[15] = dsspletter[jj] ;
      out << line << endl ;
      if ( i == spnode ) strcpy ( spline_ss, line );
      in.getline( line, sizeof(line) ) ; // whatever follows node_ss line
    }
    
    // look for NODE_RAMA line
    while  ( strncmp(line,"node_rama ",10)!=0 ) {
      if  ( strncmp(line,"node ",5)==0 ) break;
      if  ( strncmp(line,"transit_freqs ",14)==0 ) break;
      out << line << endl ; 
      in.getline( line, sizeof(line) ) ; 
    }
    if  ( strncmp(line,"node ",5)==0 ) continue ;
    if  ( strncmp(line,"transit_freqs ",14)==0 ) break;

    // output new NODE_RAMA line
    if  ( strncmp(line,"node_rama ",10)==0 ) {
      l_ptr = line+20;
      x = 0.; jj=MRAMA-1 ;    // write out r-vector and get maximum
      for (j=0 ; j<MRAMA ; j++) {
        if (mod.r[i][j] > x) {x = mod.r[i][j]; jj = j; }
        sprintf(l_ptr,"%8.3f",mod.r[i][j]) ;  // NOTE: eol gets overwritten!
        l_ptr += 8;
      }
      line[17] = ramach[jj] ;
      out << line << endl << flush ;
      if ( i == spnode ) strcpy ( spline_rama, line );
      in.getline( line, sizeof(line) ) ; // whatever follows node_rama line
    }

#ifdef USE_CONTEXT
    // look for NODE_CONTEXT line
    while  ( strncmp(line,"node_context ",13)!=0 ) {
      if  ( strncmp(line,"node ",5)==0 ) break;
      if  ( strncmp(line,"transit_freqs ",14)==0 ) break;
      out << line << endl ; 
      in.getline( line, sizeof(line) ) ; 
    }

#ifdef WRITE_NEW_CONTEXT
    // no context lines in hmm file, write out mod.c[][]
    // anyway using latest node number and character
    l_ptr = aline;
    x = 0.; jj=-1 ;
    for (j=0;j<MCTXT;j++) if (mod.c[i][j] > x) {x = mod.c[i][j]; jj=j; }
    ctxtchar = '0';
    if (jj>=0) ctxtchar = context_ch[jj] ;
    sprintf(l_ptr,"%13s%3d %c  %c  ","node_context ",i,nodechar,ctxtchar) ;  
    l_ptr = aline+23;
    for (j=0 ; j<MCTXT ; j++) {
      sprintf(l_ptr,"%8.3f",mod.c[i][j]) ;  // NOTE: eol gets overwritten!
      l_ptr += 8;
    }
    out << aline << endl << flush ;
    if ( i == spnode ) strcpy ( spline_context, aline );
    if  ( strncmp(line,"node ",5)==0 ) continue ;
    if  ( strncmp(line,"transit_freqs ",14)==0 ) break;
#else
    if  ( strncmp(line,"node ",5)==0 ) continue ;
    if  ( strncmp(line,"transit_freqs ",14)==0 ) break;

    // output new NODE_CONTEXT line
    if  ( strncmp(line,"node_context ",13)==0 ) {
      l_ptr = line+23;
      x = 0.; jj=MCTXT-1 ;    // write out r-vector and get maximum
      for (j=0 ; j<MCTXT ; j++) {
        if (mod.c[i][j] > x) {x = mod.c[i][j]; jj = j; }
        sprintf(l_ptr,"%8.3f",mod.c[i][j]) ;  // NOTE: eol gets overwritten!
        l_ptr += 8;
      }
      line[20] = context_ch[jj] ;
      out << line << endl << flush ;
      if ( i == spnode ) strcpy ( spline_context, line );
      in.getline( line, sizeof(line) ) ; // whatever follows node_context line
    } 
#endif
#endif

  }

  // Output L unit **optional**

  if ( spnode==-1 ){
    for ( i=N-8 ; i<N ; i++ ){

        strcpy(line,"node ") ; 
	sprintf( line+5, "%3d", i ) ; 
	sprintf( line+8, "%s", " z   0") ;
	sprintf( line+14, "%8.5f", mod.prior[i] ) ; 
	sprintf( line+22, "%8.2f", mod.dih[i][0] )  ;
	sprintf( line+30, "%8.2f", mod.dih[i][1] )  ;
	sprintf( line+38, "%8.2f", mod.dih[i][2] )  ;
	sprintf( line+46, " %s", "component=z  99 class=Z ss=" ) ; 
	sprintf( line+74, "%c", mod.ss[i] ) ; 
	out << line << endl ;  

       // write out new b[] vector for split node
        strcpy(line," ") ; // empty line
        for (j=0 ; j<10 ; j++) sprintf(line+(j*8),"%8.5f",mod.b[i][j]) ;
        out << line << endl ; 
        for (j=10 ; j<20 ; j++) sprintf(line+((j-10)*8),"%8.5f",mod.b[i][j]) ;
        out << line << endl << flush ; 
    }
  }


  // If new node by splitting: write parameters for new node 

      if ( spnode> 0 ) {

	cout << "Writing new node information" << endl; 
	cout << "Nodestring: " << spline << endl ; 

       // write out split node line
        strcpy(line,"node ") ; 
	sprintf( line+5, "%3d", N-1 ) ; 
	out << line ; 
        strcpy ( line, spline+8 ) ;
        out << line << endl ; 

       // write out new b[] vector for split node
        strcpy(line," ") ; // empty line
        for (j=0 ; j<10 ; j++) sprintf(line+(j*8),"%8.5f",mod.b[i][j]) ;
        out << line << endl ; 
        for (j=10 ; j<20 ; j++) sprintf(line+((j-10)*8),"%8.5f",mod.b[i][j]) ;
        out << line << endl << flush ; 

       // write node_ss line
        strcpy(line,"node_ss ") ; 
	sprintf( line+8, "%3d", N-1 ) ; 
	out << line ; 
        strcpy ( line, spline_ss+11 ) ;
        out << line << endl ; 

       // write node_rama line 
        strcpy(line,"node_rama ") ; 
	sprintf( line+10, "%3d", N-1 ) ; 
	out << line ; 
        strcpy ( line, spline_rama+13 ) ;
        out << line << endl ; 

       // write node_context line 
        strcpy(line,"node_context ") ; 
	sprintf( line+13, "%3d", N-1 ) ; 
	out << line ; 
        strcpy ( line, spline_context+16 ) ;
        out << line << endl ; 

        in.getline( line, sizeof(line) )  ;   // whatever follows it

      }

  // Write a_ij 

  out << "transit_freqs  " << setw(3) << N << " " 
      << setw(3) << N << " _abcdetc." << endl ;
  for ( i=0 ; i<N ; i++ ){ 
    for ( j=0 ; j<N ; j++ ){
      out << " " << setprecision(5) << setiosflags(ios::fixed ) 
          <<  mod.a[i][j];
      }
    out << endl << flush ;
  }

  in.close()  ; 
  out.close() ; 
 
}
//
//                                May 13, 1998
// 
//   intrans_get.C - nonzero transitions into all nodes 
//                   intrans[i][0] - number of nonzero transitions into i 
//                   intrans[i][j] - node numbers for nonzero transitions
//
//

void intrans_get ( int ***intrans, struct model md ) 
{
  
  int N, i, j, count ; 

  N = md.N ; 

  *intrans = new int*[N] ;
  for ( j = 0 ; j < N ; j++ ){ 
    count = 0 ;
    for ( i = 0 ; i < N ; i++ ){
      if ( md.a[i][j] != 0 ) count++ ; 
    }
    (*intrans)[j] = new int[count+1] ;
    count = 0 ; 
    for ( i = 0 ; i < N ; i++ ){
      if ( md.a[i][j] != 0 ){
	count++ ;
	(*intrans)[j][count] = i ;
      }
      (*intrans)[j][0] = count ; 
    }
  }

}
//
//                                May 13, 1998
// 
//   outrans_get.C - nonzero transitions out of nodes 
//                   outtrans[i][0] - number of nonzero transitions out of i 
//                   outrans[i][j] - node numbers for nonzero transitions
//
//

void outtrans_get ( int ***outtrans, struct model md ) 
{
  
  int N, i, j, count ; 

  N = md.N ;

  *outtrans = new int*[N] ;

  for ( i = 0 ; i < N ; i++ ){
    count = 0 ; 
    for ( j = 0 ; j < N ; j++ ){
      if ( md.a[i][j] != 0 ) count++ ;
    }
    (*outtrans)[i] = new int[count+1] ;    
    count = 0 ;
    for ( j = 0 ; j < N ; j++ ){
      if ( md.a[i][j] != 0 ){
	count++ ;
	(*outtrans)[i][count] = j ;
      }
      (*outtrans)[i][0] = count ; 
    }
  }

}


//
//                                February 26, 1998
// 
//   snode_get.C - 
// 
//                   snode[0][0] - number of helical nodes
//                   snode[1][0] - number of extended ( strand ) nodes
//                   snode[2][0] - number of loop nodes 
//                   snode[3][0] - number of psi = 0 nodes 
//
//                   snode[i][j] - node numbers each i 
//
//

#define Nstructs 4 
#define Nsmax 300 

void snode_get ( int ***snode, struct model md ) 
{
  
  int N, i, j, is ; 

  N = md.N ; 

  (*snode) = new int*[Nstructs] ; 
  for ( i = 0 ; i < Nstructs ; i++ ){
    (*snode)[i] = new int[Nsmax] ;
    for ( j=0 ; j<Nsmax ; j++ ) (*snode)[i][j] = 0 ;
  }                   

  for ( i=1 ; i<N ; i++ ) {
    is = iramachandran ( md.dih[i][0], md.dih[i][1]  ) ; 
    ((*snode)[is][0])++ ; 
    (*snode)[is][ (*snode)[is][0] ] = i ; 
  }
}


//
//                                        May 28, 1998
//
//  dnode_get.C - 
//
//                   dnode[0][0] - number of helical nodes
//                   dnode[1][0] - number of extended ( strand ) nodes
//                   dnode[2][0] - number of loop nodes 
//
//                   dnode[i][j] - node numbers each i 
//
#define M3 3
void dnode_get ( int ***dnode, struct model md ) 
{

  int N, i, j, id ; 

  N = md.N ; 

  (*dnode) = new int*[M3] ; 
  for ( i = 0 ; i < M3 ; i++ ){
    (*dnode)[i] = new int[Nsmax] ;
    for ( j=0 ; j<Nsmax ; j++ ) (*dnode)[i][j] = 0 ;
  }                   

  for ( i=1 ; i<N ; i++ ) {
    id = threestate ( md.ss[i] ) ; 
    if ( id == -1 ) cerr << "DSSP Error in model file " << endl ; 
    ((*dnode)[id][0])++ ; 
    (*dnode)[id][ (*dnode)[id][0] ] = i ; 
  }
}


//
//   				October 30, 1997
//
//     Olambda.C - probability of sequence of residues given model 
//            Divided by: probability of sequence of residues
//                     given background emsission probability 
//
//            Input:  Residue sequence, sequence length, model
//            Output: Probability of residue sequence w. above normalization
// 

float Olambda( char *O_ptr, short int TT, struct model modll )
{
  int i, j, t;
  int O[Tmax];
  float ss; 
  float *alfo, *alfn ; 

// Convert sequence to integer array 

  aminotoi ( O_ptr, TT, O ); 

// Compute probability 

  alfo = new float[modll.N] ; 
  alfn = new float[modll.N] ; 

  for ( i = 0 ; i < modll.N ; i++ ){ 
    alfo[i] = modll.prior[i] * modll.b[i][O[0]]/modll.bground[O[0]] ;
  }             // Initialize by pi = modll.prior

  for ( t = 1; t < TT; t++ ){

    for ( j = 0; j < modll.N; j++ ){
      ss = 0.;
      for ( i = 0; i < modll.N; i++ ) ss += alfo[i] * modll.a[i][j] ;
      alfn[j] = ss * modll.b[j][O[t]] / modll.bground[O[t]];
    }
    for ( j = 0; j < modll.N; j++ ) alfo[j] = alfn[j];

  }

  ss = 0.;
  for ( i = 0; i < modll.N ; i++ ) ss += alfn[i];

  return ss ; 

}


//
// New version of Olambda, using state 0 as the NOT-state
//  26-FEB-99  cb
//
float Olambda0( char *O_ptr, short int TT, struct model modll )
{
  int i, j, t;
  int O[Tmax];
  float ss; 
  float *alfo, *alfn ; 

// Convert sequence to integer array 

  aminotoi ( O_ptr, TT, O ); 

// Compute probability 

  alfo = new float[modll.N] ; 
  alfn = new float[modll.N] ; 

  for ( i = 1 ; i < modll.N ; i++ ){ 
    // alfo[i] = modll.prior[i] * modll.b[i][O[0]]/modll.bground[O[0]] ;
    alfo[i] = modll.a[0][i] * modll.b[i][O[0]]/modll.bground[O[0]] ;
    // alfo[i] = modll.b[i][O[0]]/modll.bground[O[0]] ;
  }             // new pi = a[0][i]

  for ( t = 1; t < TT; t++ ){

    for ( j = 1; j < modll.N; j++ ){
      ss = 0.;
      for ( i = 1; i < modll.N; i++ ) {
        ss += alfo[i] * (modll.a[i][j] + modll.a[i][0]*modll.a[0][j]);
      }
      alfn[j] = ss * modll.b[j][O[t]] / modll.bground[O[t]];
    }
    for ( j = 1; j < modll.N; j++ ) alfo[j] = alfn[j];

  }

  ss = 0.;
  for ( i = 1; i < modll.N ; i++ ) ss += alfn[i];

  return ss ; 

}

void features_print( struct model md, int** intrans, int** outtrans, ofstream* stream )
{

  int i, j, N, trans_count, one_count, node_count, sink_count, source_count;

  N = md.N ;

  // Number of actual nodes ( nonzero priors )

  node_count = 0 ;
  for ( i=0 ; i<N ; i++ ){
    if ( md.prior[i] != 0 ) node_count++ ;
  }

  // Number of non-zero transitions

  trans_count = 0 ;
  one_count = 0 ;
  for ( i=0 ; i<N ; i++ ){
    for ( j=0 ; j<N ; j++ ){
      if ( md.a[i][j] > 0 ){
        trans_count++ ;
        if ( md.a[i][j] == 1 ) one_count++ ;
      }
    }
  }

  // Find sources
  source_count = 0 ;
  for ( i=0 ; i<N ; i++ ){
    if ( md.prior[i] > 0 ){
      if ( intrans[i][0] == 0 ){
        //      *stream << "Node " << i << " has no incoming transition" ;
        source_count++ ;
      }
    }
  }
  // Find sinks
  sink_count = 0 ;
  for ( i=0 ; i<N ; i++ ){
    if ( md.prior[i] > 0 ){
      if ( outtrans[i][0] == 0 ){
        sink_count++ ;
        //      *stream << "Node " << i << " has no outgoing transition" ;
      }
    }
  }

  *stream << "Nodes: " << node_count <<
    ", Transitions : " << trans_count <<
    ", Non-unit transitions: " << trans_count-one_count ;
  if ( source_count ) *stream << ", Sources: " << source_count ;
  if ( sink_count   ) *stream << ", Sinks: "   << sink_count ;
  *stream << endl ;

}


